Subject: bug#18177: chroot: "No such file or directory" message is so confusing

From: Pádraig Brady <[email-masked]>
Date: Sun, 03 Aug 2014 05:33:20 +0100

tag 18177 notabug
close 18177
stop

On 08/03/2014 03:19 AM, T R wrote:
>    chroot: Failed to run command '/bin/bash': No such file or directory
>    This needs to be updated with more information. It pops up when:
> 
>    1) The file is actually not there
>    2) The file's dependent libraries are not there
>    3) The file and its libraries are there, but it can't run for some
>    reason
> 
>    This is too many causes to be indicated by such a brief and
>    undocumented error message.
> 
>    Version: Every version ever
>    Distribution: Every distribution of GNU/Linux

It's exactly the reason that there can be so many causes for the error
that chroot can only indicate the error code and leave further investigation
to the user. You might be thinking that chroot could check that the
executable was present and could adjust the error accordingly.
Though that would be racy and awkward to implement due to having
to handle $PATH searching etc. So we're doing the appropriate thing here.

thanks,
Pádraig.